#include "Form1.frm"

/*
 * Evento OnCreate.
 */
METHOD Form1OnCreate( oSender ) CLASS TForm1

   SET DATE TO BRITISH
   SET CENTURY ON

return

/*
 * Evento OnClick.
 */
METHOD Button1OnClick( oSender ) CLASS TForm1

   local aItems, nI
   
   if Empty( ::Server:Caption )
      ::Server:SetFocus()
      return
   endif

   if Empty( ::User:Caption )
      ::User:SetFocus()
      return
   endif

   ::Ftp1:Host := ::Server:Caption
   ::Ftp1:User := ::User:Caption
   ::Ftp1:Password := ::Password:Caption
   ::Button1:Enabled := .F.
   ::StringGrid1:SetFocus()
   ::StringGrid1:Items := {}
   ::Ftp1:Open()

   do while ::Ftp1:Busy
      Application:ProcessMessages()
   enddo

   ::Button1:Enabled := .T.

   if !::Ftp1:Active
      return
   endif
   
   ::Button2:Visible := .T.
   ::Button1:Visible := .F.
   aItems := {}

   for nI := 1 to Len( ::Ftp1:Files )
      aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                      "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                      Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                      DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                      ::Ftp1:Files[ nI ][ 5 ] } )
   next

   ::StringGrid1:Alignments := { taLeftJustify, taRightJustify, taCenter }
   ::StringGrid1:Items := aItems
   ::StringGrid1:Row := 1

return

/*
 * Evento OnClick.
 */
METHOD Button2OnClick( oSender ) CLASS TForm1

   ::StringGrid1:Items := {}
   ::StringGrid1:Row := 1
   ::Ftp1:Close()
   ::Button1:Visible := .T.
   ::Button2:Visible := .F.

return

/*
 * Evento OnDblClick.
 */
METHOD StringGrid1OnDblClick( oSender ) CLASS TForm1

   local aItems, nI, cDirectory

   if Len( ::StringGrid1:Items ) > 0 .and. ::StringGrid1:Items[ ::StringGrid1:Row ][ 5 ]
      cDirectory := ::StringGrid1:Items[ ::StringGrid1:Row ][ 1 ]
      cDirectory := SubStr( cDirectory, 2, Len( cDirectory ) - 2 )

      if ::Ftp1:ChangeDirectory( cDirectory )
         aItems := {}

         for nI := 1 to Len( ::Ftp1:Files )
            aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                            "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                            Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                            DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                            ::Ftp1:Files[ nI ][ 5 ] } )
         next

         ::StringGrid1:Items := aItems
         ::StringGrid1:Row := 1
      endif
   endif

return

/*
 * Evento MenuItem OnClick.
 */
METHOD CrearDirectorioClick( oSender ) CLASS TForm1

   local cDirectory, aItems, nI

   if !::Ftp1:Active
      return
   endif

   cDirectory := Space( 255 )
   
   if MessageDlgEdit( "Crear Directorio", "Nombre:", @cDirectory, Replicate( "X", 255 ), ;
      160, poActiveCenter ) != mrOk
      return
   endif

   cDirectory := AllTrim( cDirectory )

   if Empty( cDirectory )
      return
   endif

   if ::Ftp1:CreateDirectory( cDirectory )
      aItems := {}

      for nI := 1 to Len( ::Ftp1:Files )
         aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                         "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                         Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                         DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                         ::Ftp1:Files[ nI ][ 5 ] } )
      next

      ::StringGrid1:Items := aItems
      ::StringGrid1:Row := 1
   endif

return

/*
 * Evento MenuItem OnClick.
 */
METHOD BorrarDirectorioClick( oSender ) CLASS TForm1

   local aItems, nI, cDirectory

   if Len( ::StringGrid1:Items ) > 0 .and. ::StringGrid1:Items[ ::StringGrid1:Row ][ 5 ]
      cDirectory := ::StringGrid1:Items[ ::StringGrid1:Row ][ 1 ]
      cDirectory := SubStr( cDirectory, 2, Len( cDirectory ) - 2 )

      if cDirectory == "." .or. cDirectory == ".."
         return
      endif

      if MessageDlg( "Quiere eliminar el directorio " + cDirectory + "?", mtConfirmation, ;
                     mbOkCancel, poActiveCenter ) == mrCancel
         return
      endif

      if ::Ftp1:RemoveDirectory( cDirectory )
         aItems := {}

         for nI := 1 to Len( ::Ftp1:Files )
            aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                            "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                            Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                            DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                            ::Ftp1:Files[ nI ][ 5 ] } )
         next

         ::StringGrid1:Items := aItems
         ::StringGrid1:Row := 1
      endif
   endif

return

/*
 * Evento MenuItem OnClick.
 */
METHOD EnviarArchivoClick( oSender ) CLASS TForm1

   local aItems, nI, oForm
   
   if !::Ftp1:Active
      return
   endif

   ::OpenDialog1:FileName := ""

   if ::OpenDialog1:Execute()
      oForm := MessageDlg( "Enviando el archivo, por favor espere...", mtCustom )
      ::Enabled := .F.

      if ::Ftp1:SendFile( ::OpenDialog1:FileName )
         aItems := {}

         for nI := 1 to Len( ::Ftp1:Files )
            aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                            "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                            Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                            DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                            ::Ftp1:Files[ nI ][ 5 ] } )
         next

         ::StringGrid1:Items := aItems
         ::StringGrid1:Row := 1
      endif

      ::Enabled := .T.
      oForm:Destroy()
   endif

return

/*
 * Evento MenuItem OnClick.
 */
METHOD RecibirArchivoClick( oSender ) CLASS TForm1

   local cFileName, oForm
   
   if !::Ftp1:Active .or. ::StringGrid1:Items[ ::StringGrid1:Row ][ 5 ]
      return
   endif

   cFileName := ::StringGrid1:Items[ ::StringGrid1:Row ][ 1 ]
   ::OpenDialog1:FileName := cFileName

   if ::OpenDialog1:Execute()
      oForm := MessageDlg( "Recibiendo el archivo, por favor espere...", mtCustom )
      ::Enabled := .F.
      ::Ftp1:ReceiveFile( cFileName, ::OpenDialog1:FileName )
      ::Enabled := .T.
      oForm:Destroy()
   endif

return

/*
 * Evento MenuItem OnClick.
 */
METHOD BorrarArchivoClick( oSender ) CLASS TForm1

   local aItems, nI, cFileName

   if Len( ::StringGrid1:Items ) > 0 .and. !::StringGrid1:Items[ ::StringGrid1:Row ][ 5 ]
      cFileName := ::StringGrid1:Items[ ::StringGrid1:Row ][ 1 ]

      if MessageDlg( "Quiere eliminar el archivo " + cFileName + "?", mtConfirmation, ;
                     mbOkCancel, poActiveCenter ) == mrCancel
         return
      endif

      if ::Ftp1:DeleteFile( cFileName )
         aItems := {}

         for nI := 1 to Len( ::Ftp1:Files )
            aAdd( aItems, { If( ::Ftp1:Files[ nI ][ 5 ], "[" + ::Ftp1:Files[ nI ][ 1 ] + ;
                            "]", ::Ftp1:Files[ nI ][ 1 ] ), ;
                            Transform( ::Ftp1:Files[ nI ][ 2 ], "@E 999,999,999" ), ;
                            DToC( ::Ftp1:Files[ nI ][ 3 ] ), ::Ftp1:Files[ nI ][ 4 ], ;
                            ::Ftp1:Files[ nI ][ 5 ] } )
         next

         ::StringGrid1:Items := aItems
         ::StringGrid1:Row := 1
      endif
   endif

return

/*
 * Evento OnProgress.
 */
METHOD Ftp1OnProgress( oSender, nOperation ) CLASS TForm1

   do case
      case nOperation == 1
         ::LabelStatus:Caption := "Preparado."

      case nOperation == 2
         ::LabelStatus:Caption := "Conectando..."

      case nOperation == 3
         ::LabelStatus:Caption := "Recuperando la lista de archivos..."

      case nOperation == 4
         ::LabelStatus:Caption := "Cambiando de directorio..."

      case nOperation == 5
         ::LabelStatus:Caption := "Creando el directorio..."

      case nOperation == 6
         ::LabelStatus:Caption := "Eliminando el directorio..."

      case nOperation == 7
         ::LabelStatus:Caption := "Enviando el archivo..."

      case nOperation == 8
         ::LabelStatus:Caption := "Recibiendo el archivo..."

      case nOperation == 9
         ::LabelStatus:Caption := "Eliminando el archivo..."

      case nOperation == 10
         ::LabelStatus:Caption := "Desconectando..."
   endcase

return

/*
 * Evento OnError.
 */
METHOD Ftp1OnError( oSender, nEvent, nError ) CLASS TForm1

   do case
      case nEvent == eeConnect
         MessageDlg( "No se puede conectar.", mtError, mbOk, poActiveCenter )

      case nEvent == eeDisconnect
         MessageDlg( "No se cerr la conexin correctamente.", mtError, mbOk, poActiveCenter )

      case nEvent == eeLookup
         MessageDlg( "No se encontr el nombre del servidor.", mtError, mbOk, poActiveCenter )

      case nEvent == eeReceive
         MessageDlg( "Error al recibir datos.", mtError, mbOk, poActiveCenter )

      case nEvent == eeSend
         MessageDlg( "Error al enviar datos.", mtError, mbOk, poActiveCenter )

      case nEvent == eeGeneral
         MessageDlg( "Error genrico.", mtError, mbOk, poActiveCenter )
   endcase

return